const protocol = 'js://tencent.tmf.hyb?';
let TMFStat = new TmfH5StatImp();

function TmfH5StatImp() {
}

/**
 * 设置H5页面名称
 * @param pageName 页面名称
 */
TmfH5StatImp.prototype.setPageName = function (pageName) {
    if (!isNotNull(pageName)) {
        return;
    }

    let data = {
        methodName: 'setPageName',
        args: {
            pageName: pageName,
            path: window.location.href,
            ts: getTimestamp()
        }
    };

    window.location = protocol + encodeURIComponent(JSON.stringify(data));
};

/**
 * 自定义事件，此类事件通常用于统计次数
 * @param eventId 自定义事件的id，不能为null或""
 * @param map 自定义属性, String类型的key-Value对
 * @param lbl 用户标签, String类型的key-Value对
 */
TmfH5StatImp.prototype.trackCustomKVEvent = function (eventId, map, lbl) {
    if (!isNotNull(eventId)) {
        return;
    }

    let data = {
        methodName: 'trackCustomKVEvent',
        args: {
            eventId: eventId,
            path: window.location.href,
            map: map,
            lbl: lbl,
            ts: getTimestamp()
        }
    };

    window.location = protocol + encodeURIComponent(JSON.stringify(data));
};

/**
 * 自定义时长事件，此类事件通常用于统计次数
 * @param eventId 自定义事件的id，不能为null或""
 * @param duration 事件耗时，单位由业务约定
 * @param map 自定义属性, String类型的key-Value对
 * @param lbl 用户标签, String类型的key-Value对
 */
TmfH5StatImp.prototype.trackCustomKVTimeIntervalEvent = function (eventId, duration, map, lbl) {
    if (!isNotNull(eventId)) {
        return;
    }

    let data = {
        methodName: 'trackCustomKVTimeIntervalEvent',
        args: {
            eventId: eventId,
            path: window.location.href,
            duration: duration,
            map: map,
            lbl: lbl,
            ts: getTimestamp()
        }
    };

    window.location = protocol + encodeURIComponent(JSON.stringify(data));
};

/**
 * 设置用户自定义的user id
 * @param userId 用户自定义的user id
 * @param lbl 用户标签, String类型的key-Value对
 */
TmfH5StatImp.prototype.setCustomUserId = function (userId, lbl) {
    if (!isNotNull(userId)) {
        return;
    }

    let data = {
        methodName: 'setCustomUserId',
        args: {
            userId: userId,
            path: window.location.href,
            lbl: lbl,
            ts: getTimestamp()
        }
    };

    window.location = protocol + encodeURIComponent(JSON.stringify(data));
};

function getTimestamp() {
    return (new Date).getTime();
}

function isNotNull(ele) {
    if (typeof ele === 'undefined') {//先判断类型
        return false;
    } else if (ele == null) {
        return false;
    } else if (ele === '') {
        return false;
    }
    return true;
}